]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- 1.467; no tabs/spaces in front of xorg deps
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# PLD Linux rpm macros
3
4%epoch 0
5%x8664 x86_64 amd64 ia32e
6
7# kernel compiler
8%kgcc %{__cc}
9%kgcc_package gcc
10
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
14
15%__rm /bin/rm --interactive=never
16
17# Build system path macros.
18#
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
21%__autopoint autopoint --force
22
23%__gettextize { \
24 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
25 gettextize --copy --force --no-changelog; \
26 else \
27 gettextize --copy --force --no-changelog --intl; \
28 fi; \
29 if [ ! -f po/Makevars ]; then \
30 cp -f po/Makevars{.template,}; \
31 fi; \
32}
33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
36%__gnome_doc_prepare gnome-doc-prepare --copy --force
37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
39%__libtoolize libtoolize --copy --force --install
40
41# Path to top of build area.
42%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
43
44# The number of cvs changelog entries kept when building package.
45%_buildchangelogtruncate 20
46
47%dependencytracking %{nil}
48
49# Relations between package names that cause dependency loops
50# with legacy packages that cannot be fixed. Relations are
51# specified as
52# p>q
53# where package p has a Requires: on something that package q Provides:
54#
55# XXX Note: that there cannot be any whitespace within the string "p>q",
56# and that both p and q are package names (i.e. no version/release).
57%_dependency_whiteout %{nil}
58
59%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
60 && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
61 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
62
63#-----------------------------------------------------------------
64#
65# (re)definition of %{rpm*flags} with %filterout_* support
66# BuildRequires: awk
67# BuildRequires: rpmbuild(macros) >= 1.315
68#
69# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
70# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
71# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
72# %rpmldflags = %optldflags - %filterout_ld
73#
74# Regular expressions are supported, but to avoid some character be treated
75# as regular expression it must be escaped twice.
76
77%filter_out \
78 for (i = 1; i in I; i++) { A=0; \
79 for (f in F) { \
80 if (I[i] ~ "^" F[f] "$") A=1; \
81 }; \
82 if (!A) printf(I[i] FS); \
83 }
84
85%rpmcflags %(awk 'BEGIN {
86 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
87 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
88 %{filter_out}
89}')
90
91%rpmcxxflags %(awk 'BEGIN {
92 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
93 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
94 %{filter_out}
95}')
96
97%rpmldflags %(awk 'BEGIN {
98 split("%{?optldflags}",I);
99 split("%{?filterout_ld}",F)
100 %{filter_out}
101}')
102
103# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
104# but, don't use it, better use gcc as linker
105%ld_rpmldflags %(awk 'BEGIN {
106 split("%{rpmldflags}",F);
107 for (f in F) {
108 s = F[f];
109 if (s ~ /^-Wl,/) {
110 s = substr(s,5);
111 gsub(/,/," ",s);
112 };
113 printf(s FS);
114 };
115}')
116
117#-----------------------------------------------------------------
118%configure2_13 { \
119 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
120 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
121 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
122 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
123 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
124 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
125 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
126 %{?__cc:CC="%{__cc}" ; export CC ; } \
127 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
128 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
129 --host=%{_target_platform} \
130 --prefix=%{_prefix} \
131 --exec-prefix=%{_exec_prefix} \
132 --bindir=%{_bindir} \
133 --sbindir=%{_sbindir} \
134 --sysconfdir=%{_sysconfdir} \
135 --datadir=%{_datadir} \
136 --includedir=%{_includedir} \
137 --libdir=%{_libdir} \
138 --libexecdir=%{_libexecdir} \
139 --localstatedir=%{_localstatedir} \
140 --sharedstatedir=%{_sharedstatedir} \
141 --mandir=%{_mandir} \
142 --infodir=%{_infodir} \
143 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
144 %{dependencytracking} \
145}
146
147# override __cmake to add -j4 in your ~/.rpmmacros for parallel make
148%__cmake /usr/bin/cmake
149%cmake { \
150CC="%{__cc}" \
151CXX="%{__cxx}" \
152CFLAGS="%{rpmcflags}" \
153CXXFLAGS="%{rpmcxxflags}" \
154%{__cmake} \
155}
156
157# override __scons to add -j4 in your ~/.rpmmacros for parallel make
158%__scons /usr/bin/scons
159%scons { \
160%{__scons} \
161 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
162 CFLAGS="${CFLAGS:-%rpmcflags}" \
163 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
164 FFLAGS="${FFLAGS:-%rpmcflags}" \
165 CPPFLAGS="${CPPFLAGS:-}" \
166 %{?__cc:CC="%{__cc}"} \
167 %{?__cxx:CXX="%{__cxx}"} \
168 libsuffix=%{_lib} \
169 prefix=%{_prefix} \
170}
171
172# waf. see waf.spec
173# override __waf to add -j4 in your ~/.rpmmacros for parallel make
174%__waf /usr/bin/waf
175%waf { \
176CC="%{__cc}" \
177CXX="%{__cxx}" \
178CPP="%{__cpp}" \
179CFLAGS="%{rpmcflags}" \
180CXXFLAGS="%{rpmcxxflags}" \
181%{__waf} \
182}
183
184#----------------------------------------------------------------
185#%configure_cache 0
186%configure_cache_file %{buildroot}.configure.cache
187
188%configure {./configure \
189 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
190 CFLAGS="${CFLAGS:-%rpmcflags}" \
191 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
192 FFLAGS="${FFLAGS:-%rpmcflags}" \
193 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
194 CPPFLAGS="${CPPFLAGS:-}" \
195 %{?__cc:CC="%{__cc}"} \
196 %{?__cxx:CXX="%{__cxx}"} \
197 --host=%{_target_platform} \
198 --build=%{_target_platform} \
199 --prefix=%{_prefix} \
200 --exec-prefix=%{_exec_prefix} \
201 --bindir=%{_bindir} \
202 --sbindir=%{_sbindir} \
203 --sysconfdir=%{_sysconfdir} \
204 --datadir=%{_datadir} \
205 --includedir=%{_includedir} \
206 --libdir=%{_libdir} \
207 --libexecdir=%{_libexecdir} \
208 --localstatedir=%{_localstatedir} \
209 --sharedstatedir=%{_sharedstatedir} \
210 --mandir=%{_mandir} \
211 --infodir=%{_infodir} \
212 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
213 %{dependencytracking} \
214 %{?configure_cache:--cache-file=%{configure_cache_file}} \
215}
216
217# overload to insert debuginfo package
218%prep \
219%if 0%{?_enable_debug_packages}\
220%{debug_package}\
221%endif\
222%%prep\
223%{nil}
224
225# Location of autoconf macros
226%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
227
228# Location of omf files
229%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
230
231# Location of pkgconfig files
232%_pkgconfigdir /usr/%{_lib}/pkgconfig
233# noarch pkgconfig files
234%_npkgconfigdir /usr/share/pkgconfig
235
236# Location of desktop files
237%_desktopdir /usr/share/applications
238%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
239
240# Location of pixmaps for applnk/desktop files
241%_pixmapsdir /usr/share/pixmaps
242
243# Location of themable icons for applnk/desktop files
244%_iconsdir /usr/share/icons
245
246# Location of fonts directories
247%_fontsdir /usr/share/fonts
248
249# Location of Gtk and associated libraries documentation
250%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
251
252# Location of KDE documentation
253%_kdedocdir %{_defaultdocdir}/kde/HTML
254
255# unsermake script
256%__unsermake /usr/share/unsermake/unsermake
257
258# Current date
259%date %(LC_ALL="C" date +"%a %b %d %Y")
260
261# Example files, programs, scripts...
262%_examplesdir /usr/src/examples
263
264# Alternative kernel type/version
265%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
266
267# The directory holding Linux kernel sources
268%_kernelsrcdir /usr/src/linux%{_alt_kernel}
269
270# If non-empty "debug" macro defined, add "dbg" suffix to release number
271%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
272
273# Requires name = version-release
274%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
275
276%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
277%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
278%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
279%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
280%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
281%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
282
283# XXX: why epoch 0 is stripped?
284%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
285%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
286
287%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
288
289# kernel version-release handling
290%__kernel_ver %{expand:%%global __kernel_ver %( \\
291 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
292 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
293 echo ${Z:-ERROR}; \\
294)}%__kernel_ver
295
296%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
297%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
298%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
299%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
300
301# `uname -r` to be used in @release field
302%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
303
304# sgml macros
305%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
306%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
307%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
308%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
309%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
310%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
311%docbook_sgmlcat_fix() { for l in \
312'' \
313' -- default decl --' \
314'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
315' -- hacks for opensp --' \
316'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
317'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
318'' \
319; do echo $l; done >> %1 \
320}
321
322# vim - "
323
324# minimum file size needed for compressed documents.
325# just smaller files than this get larger when compressed.
326# some stats:
327# - 0 byte file compressed was 25 bytes .gz
328# - 39 byte file was compressed as 57
329# - with test/test.spec@man 158 byte file was compressed also 158
330%_min_compress_bytes 159
331
332#-----------------------------------------------------------------
333# find and gzip all files in %{_mandir} and %{infodir}
334#
335# Requires: xargs, find
336#
337#%no_install_post_compress_docs 1
338%__spec_install_post_compress_docs { \
339%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
340 for i in /usr/share/man /usr/X11R6/man; do \
341 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
342 echo "Compress man pages: $i"; \
343 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
344 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
345 find $RPM_BUILD_ROOT$i -type l | while read a; do \
346 m=$(readlink $a); \
347 rm -f $a; \
348 echo .so ${m##*/} > $a; \
349 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
350 done; \
351 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
352 fi; \
353 done; \
354 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
355 echo "Compress info pages: %{_infodir}"; \
356 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
357 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
358 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
359 fi; \
360}; __spec_install_post_compress_docs } }
361
362#-----------------------------------------------------------------
363# Strip executable binaries and shared object files
364#
365# Requires: find, awk, strip, cut, xargs
366#
367# Special macros which affect this process:
368#%no_install_post_strip 1 # disable stripping at all
369#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
370#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
371#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
372#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
373#
374%__spec_install_post_strip {%{!?debug: \
375%{!?no_install_post_strip:__spec_install_post_strip() { \
376if [ -d "$RPM_BUILD_ROOT" ]; then \
377 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
378 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
379 if [ "$modulelist" ]; then \
380 modulecount=$(echo "$modulelist" | wc -l); \
381 printf "Stripping %d kernel modules..." $modulecount; \
382 echo "$modulelist" | xargs -l512 chmod u+w; \
383 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
384 echo "DONE"; \
385 fi; \
386 fi; \
387 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
388 if [ -n "$filelist" ]; then \
389 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
390 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
391 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
392 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
393 if [ -n "$elfexelist" ]; then \
394 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
395 chmod u+w $elfexelist; \
396 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
397 echo "DONE"; \
398 fi; \
399 if [ -n "$elfsharedlist" ]; then \
400 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
401 chmod u+w $elfsharedlist; \
402 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
403 echo "DONE"; \
404 fi; \
405 if [ -n "$archiveslist" ]; then \
406 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
407 chmod u+w $archiveslist; \
408 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
409 echo "DONE"; \
410 fi; \
411 fi; \
412 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
413 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
414 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
415 if [ -n "$filelist_all" ]; then \
416 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
417 chmod u+w $filelist_all; \
418 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
419 echo "DONE"; \
420 fi; \
421 if [ -n "$filelist_unneeded" ]; then \
422 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
423 chmod u+w $filelist_unneeded; \
424 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
425 echo "DONE"; \
426 fi; \
427 if [ -n "$filelist_debug" ]; then \
428 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
429 chmod u+w $filelist_debug; \
430 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
431 echo "DONE"; \
432 fi; \
433fi; }; __spec_install_post_strip } } }
434
435#-----------------------------------------------------------------
436# remove all RPATH from executable binaries and shared object files
437#
438# Requires: find, awk, cut, xargs, chrpath, uname
439#
440# Special macros which affect this process
441#%no_install_post_chrpath 1 # disable chrpath at all
442#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
443#
444%__spec_install_post_chrpath {%{!?debug: \
445%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
446if [ -d "$RPM_BUILD_ROOT" ]; then \
447 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
448 if [ -n "$files" ]; then \
449 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
450 fi; \
451 if [ -n "$objs" ]; then \
452 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
453 echo "$objs" | \
454 while read file; do \
455 rpath= ; \
456 chmod u+w "$file"; \
457 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
458 case $dir in \
459 '$ORIGIN' ) \
460 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
461 else rpath="$rpath:$dir" ; fi ; \
462 continue ; \
463 ;; \
464 esac ; \
465 newdir=$(readlink -m "$dir"); \
466 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
467 case $dir in \
468 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
469 echo "remove-rpath: $dir in $file"; \
470 ;; \
471 * ) \
472 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
473 else rpath="$rpath:$dir" ; fi ; \
474 ;; \
475 esac ; \
476 done ; \
477 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
478 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
479 done; \
480 fi; \
481fi; }; __spec_install_post_chrpath } } }
482
483#-----------------------------------------------------------------
484# Find and gzip all kernel modules
485#
486# Requires: find
487#
488#%no_install_post_compress_modules 1
489%__spec_install_post_compress_modules { \
490%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
491 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
492 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
493 if [ "$q" ]; then \
494 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
495 echo "$q" | xargs -r %{__gzip} -9nf; \
496 echo "DONE"; \
497 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
498 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
499 fi; \
500 fi; \
501}; __spec_install_post_compress_modules } }
502
503# Remove common Perl files we don't package
504%__spec_install_post_perl_clean {\
505%{!?no_install_post_perl_clean: \
506%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
507} }
508
509#-----------------------------------------------------------------
510# Update GConf2 schemas
511#
512# Requires: GConf2
513#
514%gconf_schema_install() \
515 umask 022; \
516 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
517%{nil}
518
519%gconf_schema_uninstall() \
520if [ $1 = 0 ]; then \
521 umask 022; \
522 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
523fi; \
524%{nil}
525
526#-----------------------------------------------------------------
527# Update desktop MIME database
528# requires: desktop-file-utils
529%update_desktop_database() {{ \
530 umask 022; \
531 /usr/bin/update-desktop-database -q; \
532}}%{nil}
533
534%update_desktop_database_post %update_desktop_database
535
536%update_desktop_database_postun() {{ \
537if [ "$1" = "0" ]; then \
538 %update_desktop_database; \
539fi; \
540}}%{nil}
541
542#-----------------------------------------------------------------
543# Update shared MIME info database
544# requires: shared-mime-info
545#
546%update_mime_database() {{ \
547 umask 022; \
548 /usr/bin/update-mime-database %{_datadir}/mime; \
549}}%{nil}
550
551#-----------------------------------------------------------------
552# Update icon cache
553# requires: gtk+
554#
555%update_icon_cache() {{ \
556 umask 022; \
557 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
558}}%{nil}
559
560#-----------------------------------------------------------------
561# Update scrollkeeper database
562# requires: scrollkeeper
563#
564%scrollkeeper_update_post() \
565 /usr/bin/scrollkeeper-update -q; \
566%{nil}
567
568%scrollkeeper_update_postun() \
569if [ "$1" = "0" ]; then \
570 /usr/bin/scrollkeeper-update -q; \
571fi; \
572%{nil}
573
574#-----------------------------------------------------------------
575# post %install sequence:
576# - autodeps exceptions
577# - compress all man and info pages,
578# - strip all ELF executables and ELF shared objects if not %debug.
579# - compress kernel modules if any
580
581###################################################################
582# Requires/Provides automation
583# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
584#
585%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
586%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
587%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
588%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
589%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
590
591#%_noautocompressdoc %{nil}
592#
593%_missing_doc_files_terminate_build 1%{nil}
594%_unpackaged_files_terminate_build %{nil}
595# (X)emacs support
596%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
597%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
598%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
599
600%__php_provides %{nil}
601%__php_requires %{nil}
602%__perl_provides %{nil}
603%__perl_requires %{nil}
604%__mono_provides %{nil}
605%__mono_requires %{nil}
606
607# Perl specific macro definitions.
608%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
609%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
610%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
611%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
612%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
613%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
614
615# Ruby
616%__ruby /usr/bin/ruby
617%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
618%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
619%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
620%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
621%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
622%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
623%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
624%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
625%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
626%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
627
628%php_pear_dir /usr/share/pear
629%php_data_dir /usr/share/php
630%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
631%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
632%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
633
634# extract php/zend api versions
635%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
636%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
637%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
638%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
639%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
640%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
641%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
642
643# helper macro
644%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
645
646# macros for public use
647# for php extensions (php-pecl)
648%requires_php_extension %{__php_api_requires modules_api php_api_version} \
649%{__php_api_requires zend_module_api} \
650%{__php_api_requires -v %php_major_version debug php_debug} \
651%{__php_api_requires -v %php_major_version thread-safety zend_zts}
652
653# for zend extensions
654%requires_zend_extension %{__php_api_requires zend_module_api} \
655%{__php_api_requires zend_extension_api} \
656%{__php_api_requires -v %php_major_version debug php_debug} \
657%{__php_api_requires -v %php_major_version thread-safety zend_zts}
658
659# for php pdo modules (php-pecl-PDO_*)
660%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
661
662# for using PHP post scripts. for PHP >= 5.0
663%php_webserver_restart \
664[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
665[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
666if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
667 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
668 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
669 %service -q php-fcgi restart \
670 fi \
671fi \
672%{nil}
673
674# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
675%php4_webserver_restart \
676[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
677[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
678if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
679 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
680 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
681 %service -q php-fcgi restart \
682 fi \
683fi \
684%{nil}
685
686# X.org helper macros
687%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
688%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
689
690%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
691%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
692%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
693%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
694%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
695
696%requires_xorg_xserver_extension \
697%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
698%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
699%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
700%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
701%{nil}
702
703%requires_xorg_xserver_xinput \
704%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
705%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
706%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
707%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
708%{nil}
709
710%requires_xorg_xserver_font \
711%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
712%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
713%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
714%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
715%{nil}
716
717%requires_xorg_xserver_videodrv \
718%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
719%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
720%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
721%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
722%{nil}
723
724# Python specific macro definitions.
725# python main version
726%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
727
728# directories
729%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
730%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
731%py_scriptdir %{py_prefix}/share/python%{py_ver}
732%py_incdir /usr/include/python%{py_ver}
733%py_sitedir %{py_libdir}/site-packages
734%py_sitescriptdir %{py_scriptdir}/site-packages
735%py_dyndir %{py_libdir}/lib-dynload
736
737# pure python modules compilation
738%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
739
740%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
741
742# Software written in Python language require Python with main version
743%pyrequires_eq() Requires: %1
744
745# Hardlink binary identical .pyc and .pyo files
746# (idea by glen <at> pld-linux <dot> org)
747%__spec_install_post_py_hardlink {\
748%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
749[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
750 b="${a%.pyc}.pyo"; \
751 if cmp -s "$a" "$b"; then \
752 ln -f "$a" "$b"; \
753 fi; \
754done \
755}; __spec_install_post_py_hardlink } }
756
757# remove python sources, so that check-files won't complain
758# (idea by glen <at> pld-linux <dot> org)
759%py_postclean() \
760for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
761 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
762done \
763%{nil}
764
765# depmod macro
766%depmod() { \
767umask 022; \
768if [ -e /boot/System.map-%1 ]; then \
769 /sbin/depmod -a -F /boot/System.map-%1 %1; \
770else \
771 if [ -e /boot/System.map ]; then \
772 /sbin/depmod -a -F /boot/System.map %1; \
773 else \
774 /sbin/depmod -a %1; \
775 fi \
776fi; \
777}
778
779# XMMS specific macros
780%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
781%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
782%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
783%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
784%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
785%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
786%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
787%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
788%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
789%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
790
791%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
792
793# user/group checking macros
794#
795# Usage:
796# %userremove myuser
797#
798%userremove /usr/lib/rpm/user_group.sh user del
799%groupremove /usr/lib/rpm/user_group.sh group del
800#
801# Usage:
802# if %usertestrm myuser; then
803# /usr/sbin/userdel -r myuser
804# Note:
805# use these macros only if you need to call userdel/groupdel with
806# a non-standard option or take an extra action; otherwise use the
807# %userremove/%groupremove macros
808#
809%usertestrm /usr/lib/rpm/user_group.sh user testrm
810%grouptestrm /usr/lib/rpm/user_group.sh group testrm
811# user group membership management macros
812#
813# Usage:
814# %addusertogroup myuser agroup
815#
816%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
817
818# banner support (useful in {pre,post}{,un} and triggers)
819#
820# Usage:
821# %banner name [-a] [-e] [-n] [-tn] <<EOF
822# the banner text, the banner text
823# the banner text, and following line
824#EOF
825# You can use any form of here-document, <<'EOF' <<-EOT will do.
826# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
827#
828# -a - append to the banner
829# -e - send to stderr instead of stdout
830# -n - no show banner (overrides -t)
831# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
832#
833# Tests:
834# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
835# rpm -E 'date | %banner -e banner' > m; sh -x m
836#
837%banner(aent:) ( \
838RPM_SCRIPTVERBOSITY=5 \
839[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
840if [ -x /usr/bin/banner.sh ]; then \
841 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
842else \
843 CMD="cat%{-e: >&2}" \
844fi \
845eval $CMD %{?2:%2}%{?3: %3}) \
846%{nil}
847
848# useradd/groupadd macros
849# Author: Elan Ruusamäe <glen@pld-linux.org>
850#
851# Usage:
852# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
853# [-g initial_group] [-G group[,...]] login
854#
855# -u uid. REQUIRED
856# -g gid/group. REQUIRED
857# -s defaults to /bin/false
858# -d defaults to /usr/share/empty
859# -c No default
860# -r is accepted but ignored (it's always set)
861# -k skeleton dir. defaults to /usr/share/empty
862# rpm specific flags
863# -P package name. defaults to %{name}
864#
865%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
866%{!-u:%{error:useradd: Required argument -u missing}} \
867%{!-g:%{error:useradd: Required argument -g missing}} \
868%{!?1:%{error:useradd: Required parameter login missing}} \
869if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
870 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
871 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
872 exit 1 \
873 fi \
874else \
875 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
876 /usr/sbin/useradd \\\
877 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
878 -u %{-u*} \\\
879 -r \\\
880 -d %{-d*}%{!-d:/usr/share/empty} \\\
881 -s %{-s*}%{!-s:/bin/false} \\\
882 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
883 -g %{-g*} \\\
884 %{-M} \\\
885 %{-G:-G %{-G*}} \\\
886 %{expand:%{%{#}}} 1>&2 || exit $? \
887 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
888fi;
889
890# Usage:
891# %groupadd [-P package] [-g gid] group
892#
893# -g gid. REQUIRED
894#
895# Sample:
896# %groupadd -P %{name}-base -g %{gid} %{name}
897
898%groupadd(g:P:rfo) \
899%{!-g:%{error:groupadd: Required argument -g missing}} \
900%{!?1:%{error:groupadd: Required parameter group missing}} \
901if [ -n "`/usr/bin/getgid %{1}`" ]; then \
902 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
903 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
904 exit 1 \
905 fi \
906else \
907 echo "Adding group %{1} GID=%{-g*}." \
908 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
909 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
910fi;
911
912# webapp macros
913# Author: Elan Ruusamäe <glen@pld-linux.org>
914#
915# The config is installed/removed inside trigger, this means that you can any
916# time install apache1/apache/lighttpd package and the configuration file is
917# updated. if you don't need the config for various reason for specific
918# webserver, just remove the symlink from config directory using webapp
919# program. the trigger will not recreate the symlink on upgrades. In other
920# words the config is linked to webserver config directory on first install of
921# PACKAGE or WEBSERVER.
922#
923# Add package's webserver config to webserver webapps dir.
924# Usage:
925# %webapp_register WEBSERVER WEBAPP
926#
927%webapp_register() \
928%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
929if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
930 /usr/sbin/webapp register %1 %2\
931fi\
932# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
933if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
934 %{expand:%service -q %%1 reload}\
935fi\
936%{nil}
937
938# Remove package's config from webserver webapps dir.
939# Usage:
940# %webapp_register [-f] WEBSERVER WEBAPP
941%webapp_unregister(f) \
942%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
943# remove link if either of the packages are gone \
944if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
945 /usr/sbin/webapp unregister %1 %2\
946 %{expand:%service -q %%1 reload}\
947fi \
948%{nil}
949
950# service macro.
951# Author: Elan Ruusamäe <glen@pld-linux.org>
952#
953# calls usual service restart on package %post, but skips the restart if
954# administrator has disabled automatic service restarts in either global
955# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
956#
957# Usage:
958# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
959#
960# -q be silent when service isn't started (for scriplets restaring other package's services)
961# -n NOOP mode, do not actually restart service
962#
963# Requirements:
964# BuildRequires: rpmbuild(macros) >= 1.268
965# Requires: rc-scripts
966# -n option:
967# BuildRequires: rpmbuild(macros) >= 1.450
968%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
969
970
971# Java macros. based on jpackage macros.java
972#
973# Root directory where all Java VMs/SDK/JREs are installed.
974%_jvmdir %{_libdir}/jvm
975
976# Root directory where all Java VMs/SDK/JREs expose their jars
977%_jvmjardir %{_libdir}/jvm-exports
978
979# Root directory for all Java VM/SDK/JRE's private things.
980%_jvmprivdir %{_libdir}/jvm-private
981
982# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
983%_jvmlibdir %{_libdir}/jvm
984
985# Root directory for all architecture independent parts of Java VM/SDK/JRE's
986%_jvmdatadir %{_datadir}/jvm
987
988# Root directory for all configurations parts of Java VM/SDK/JRE's
989%_jvmsysconfdir %{_sysconfdir}/jvm
990
991# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
992%_jvmcommonlibdir %{_libdir}/jvm-common
993
994# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
995%_jvmcommondatadir %{_datadir}/jvm-common
996
997# Root directory for all common configurations parts of Java VM/SDK/JRE's
998%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
999
1000# Directory where arch-specific (JNI) version-independent jars are installed.
1001%_jnidir %{_libdir}/java
1002
1003%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
1004
1005%ant JAVA_HOME=%{java_home} ant
1006%jar %{java_home}/bin/jar
1007%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
1008%javac %{java_home}/bin/javac
1009%javadoc %{java_home}/bin/javadoc
1010
1011%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1012
1013%jpackage_script() \
1014install -d $RPM_BUILD_ROOT%{_bindir}\
1015cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1016#!/bin/sh\
1017#\
1018# %{name} script\
1019# JPackage Project <http://www.jpackage.org/>\
1020\
1021# Source functions library\
1022. %{_javadir}-utils/java-functions\
1023\
1024# Source system prefs\
1025if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1026 . %{_sysconfdir}/java/%{name}.conf\
1027fi\
1028\
1029# Source user prefs\
1030if [ -f $HOME/.%{name}rc ]; then\
1031 . $HOME/.%{name}rc\
1032fi\
1033\
1034# Configuration\
1035MAIN_CLASS=%1\
1036BASE_FLAGS=%2\
1037BASE_OPTIONS=%3\
1038BASE_JARS="%(echo %4 | tr ':' ' ')"\
1039\
1040# Set parameters\
1041set_jvm\
1042set_classpath $BASE_JARS\
1043set_flags $BASE_FLAGS\
1044set_options $BASE_OPTIONS\
1045\
1046# Let's start\
1047run "$@"\
1048EOF
1049
1050# jpackage 1.7
1051# Directory for maven depmaps
1052#
1053%_mavendepmapdir /etc/maven
1054%_mavendepmapfragdir /etc/maven/fragments
1055
1056#
1057# add_to_depmap adds an entry to the depmap. The arguments are:
1058#
1059# %1 the original groupid
1060# %2 the original artifact id
1061# %3 the version
1062# %4 the new groupid
1063# %5 the new artifactid
1064#
1065
1066%add_to_maven_depmap() \
1067install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1068cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1069<dependency>\
1070 <maven>\
1071 <groupId>%1</groupId>\
1072 <artifactId>%2</artifactId>\
1073 <version>%3</version>\
1074 </maven>\
1075 <jpp>\
1076 <groupId>%4</groupId>\
1077 <artifactId>%5</artifactId>\
1078 <version>%3</version>\
1079 </jpp>\
1080</dependency>\
1081\
1082EOF\
1083%{nil}
1084
1085#==============================================================================
1086#
1087# update_maven_depmap updates the main maven depmap
1088#
1089%update_maven_depmap() \
1090echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1091if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1092cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1093fi\
1094echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1095
1096
1097# PEAR install macros
1098# Author: Elan Ruusamäe <glen@pld-linux.org>
1099#
1100# Usage:
1101# %%pear_package_setup [-a #] [-n FMT]
1102#
1103# -a # - also unpack SOURCE#. for PEAR bootstrapping
1104# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1105# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1106#
1107# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1108# destination hierarchy. you should copy the tree to buildroot after
1109# patching/reorganizing with %%pear_package_install.
1110#
1111# additionally BUILDROOT is stripped from files and files are converted to UNIX
1112# line endings.
1113#
1114# the pear install process output is recorded to install.log, you should put it
1115# to %%doc for later debug or just for information.
1116#
1117# additionally additional-packages.txt is produced if it was detected that the
1118# package has optional dependencies. the file format is suitable of displaying
1119# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1120# automatically added for this file.
1121
1122
1123# records install.log and transforms PEAR names to PLD Linux rpm package names.
1124%__pear_install_log \
1125tee install.log \
1126# make post message of optional packages \
1127grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1128if [ -s optional-packages.txt ]; then \
1129 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1130else \
1131 rm -f optional-packages.txt \
1132fi \
1133%{nil}
1134
1135# command invoking pear cli
1136%__pear /usr/bin/pear
1137
1138%pear_install(a:n:zD) \
1139%__pear \\\
1140 -c pearrc \\\
1141 -d doc_dir=/docs \\\
1142 -d php_dir=%{php_pear_dir} \\\
1143 -d bin_dir=%{_bindir} \\\
1144 -d data_dir=%{php_pear_dir}/data \\\
1145 -d test_dir=%{php_pear_dir}/tests \\\
1146 install \\\
1147 --packagingroot=%{builddir} \\\
1148 --offline \\\
1149 --nodeps \\\
1150 %{-f:--force} \\\
1151 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1152%{nil}
1153
1154# The main macro.
1155# using this macro will append optional-packages.txt to the nocompressdoc list
1156# as it's displayed to user after package install. and adding additional gzip
1157# dep is just waste ;)
1158%pear_package_setup(a:n:zD) \
1159%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1160%define builddir %{_builddir}/%{srcdir} \
1161%setup -q -c -T %{-D:-D} -n %{srcdir} \
1162%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1163%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1164%pear_install \
1165%{-z:cd ..} \
1166cat %{-z:$_N/}.install.log | %__pear_install_log \
1167\
1168# undos sources \
1169find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1170%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1171%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1172%{nil}
1173
1174# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1175# Author: Elan Ruusamäe <glen@pld-linux.org>
1176%pear_package_install() \
1177cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1178find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1179# help the developer out a little: \
1180if [ -f _noautoreq ]; then \
1181 echo "AutoReqdep detected:" \
1182 echo "_noautoreq $(cat _noautoreq)" \
1183fi \
1184%{nil}
1185
1186
1187# Register OpenLDAP schema.
1188# Author: Elan Ruusamäe <glen@pld-linux.org>
1189#
1190# Usage:
1191# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1192#
1193# -d specify dependant schemas, separated by comma
1194#
1195%openldap_schema_register(d:) \
1196for schema in %*; do \
1197 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1198 %{__sed} -i -e " \
1199 /^include.*local.schema/{ \
1200 iinclude\\t $schema\
1201 } \
1202 " /etc/openldap/slapd.conf \
1203 fi \
1204done \
1205# enable dependant schemas \
1206if [ "%{-d*}" ]; then \
1207 %{__sed} -i -e ' \
1208 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1209 s/^#// \
1210 }' /etc/openldap/slapd.conf \
1211fi \
1212%{nil}
1213
1214# Unregister OpenLDAP schema.
1215# Author: Elan Ruusamäe <glen@pld-linux.org>
1216#
1217# Usage:
1218# %%openldap_schema_unregister %{schemadir}/horde.schema
1219#
1220%openldap_schema_unregister() \
1221for schema in %*; do \
1222 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1223 %{__sed} -i -e " \
1224 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1225 # for symmetry it would be nice if we disable enabled schemas in post, \
1226 # but we really can not do that, it would break something else. \
1227 " /etc/openldap/slapd.conf \
1228 fi \
1229done \
1230%{nil}
1231
1232%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1233
1234
1235# Build modules for kernels 2.6
1236# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1237#
1238# Usage:
1239# %build_kernel_modules -m <modules> -C <directory>
1240#
1241# remember that proper Makefile is still required
1242# Options:
1243# -m <modules> (required) -- comma-separated list of modules to save,
1244# without .ko extension, may be placed in subdirectory
1245# -C <directory> -- change to <directory> before doing anything
1246# -p <arg>, -P <arg> -- arguments passeed to make scripts
1247# -c -- do not execute make clean
1248# <additional arguments> -- all additional arguments will be passed to
1249# make modules
1250#
1251# Additional patching supported via here document. Try:
1252# %build_kernel_modules -m module <<'EOF'
1253# your patch script here
1254# EOF
1255# Don't use it unless patching depends on config options.
1256
1257# Developer note: don't touch it unless you know how to handle '\'.
1258# - \ in script expands to nothing
1259# - \\\ in script expands to \
1260# - \\\ inside definition expands to nothing
1261# - \\\\\\\ inside definition expands to \
1262# - in last line \ has to touch arguments so arguments passing
1263# in new lines (using \) will be supported
1264
1265%build_kernel_modules(p:P:m:C:c) \
1266%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1267 \
1268%define Opts \\\\\\\
1269%if "%{_target_base_arch}" != "%{_arch}" \\\
1270 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1271 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1272 %else \\\
1273 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1274 %endif \\\
1275%else \\\
1276 CC="%{kgcc}" \\\
1277%endif \
1278%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1279 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1280 \
1281%{?-C:cd %{-C*}} \
1282compile() { \
1283 local L="<" PATCH_SH; \
1284 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1285 set -e -x \
1286 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1287 \
1288for cfg in ${cfgs:-dist}; do \
1289 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1290 \
1291 rm -rf o \
1292 install -d o/include/linux \
1293 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1294 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1295 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1296 \
1297 set +x \
1298 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1299 set -x \
1300 \
1301 %if %{with dist_kernel} \
1302 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1303 %{-p*} %{-P*} \\\
1304 %{MakeOpts} \
1305 %else \
1306 install -d o/include/config \
1307 touch o/include/config/MARKER \
1308 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1309 %endif \
1310 \
1311 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1312 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
1313 ${1+"$@"} \\\
1314 M=$PWD %{MakeOpts}} \
1315 \
1316 %{__make} -C %{_kernelsrcdir} modules \\\
1317 ${1+"$@"} \\\
1318 M=$PWD %{MakeOpts} \
1319 \
1320 for MODULE in {%{-m*},}; do \
1321 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1322 done \
1323done \
1324%{?-C:cd -} \
1325} \
1326compile %{*}\
1327%{nil}
1328
1329
1330# Install kernel modules built by %build_kernel_modules
1331# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1332#
1333# Usage:
1334# %install_kernel_modules -m <modules> -d <directory>
1335#
1336# Options:
1337# -m <modules> (required) -- comma-separated list of modules to install,
1338# without .ko extension, may be placed in subdirectory
1339# -d <directory> (required) -- in what subdirectory modules should be
1340# installed (eg. misc, kernel/drivers/net)
1341# -s <suffix> -- suffix to use when installing modules, useful when module
1342# with same name exists in kernel already
1343# -n <file> -- name of modprobe config file to use (without .conf extension)
1344# for defining aliases, only useful with -s
1345
1346%install_kernel_modules(m:d:s:n:) \
1347%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1348%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1349%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1350 \
1351%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1352%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1353 \
1354local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1355 \
1356for MODULE in {%{-m*},}; do \
1357 [ -n "${MODULE}" ] || continue \
1358 for cfg in ${cfgs:-dist}; do \
1359 [ "$cfg" = smp ] && suf=smp || suf= \
1360 MNAME=${MODULE##*/} \
1361 install -D ${MODULE}-$cfg.ko \\\
1362 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1363 %{?-s:install -d %{ModprobeD}$suf \
1364 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1365 >> %{ModprobeD}$suf/%{-n*}.conf} \
1366 done \
1367done \
1368%{nil}
1369
1370# patchset macros
1371# Author: Elan Ruusamäe <glen@pld-linux.org>
1372#
1373# Usage:
1374# %patchset_source -f <seq(1) format> <start> [<end>]
1375# %patchset_patch <start> [<end>]
1376#
1377# If <end> is omited, it is assumed to be <start>.
1378#
1379# For example in preamble:
1380# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1381# and in %prep:
1382# %patchset_patch 33 44
1383
1384# generate SourceX urls from range START STOP
1385# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1386# The sources start from 10000
1387%patchset_source(f:b:) %(
1388 base=%{-b*}%{!-b*:10000};
1389 start=$(expr $base + %1);
1390 end=$(expr $base + %{?2}%{!?2:%{1}});
1391 # we need to call seq twice as it doesn't allow two formats
1392 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1393 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1394 paste %{tmpdir}/__ps{1,2};
1395 rm -f %{tmpdir}/__ps{1,2};
1396) \
1397%{nil}
1398
1399# apply sources from %patchset_source
1400# -p specify -pX for %patch line
1401# -b base offset: defaults to 10000
1402%patchset_patch(f:p:b:) %(
1403 base=%{-b*}%{!-b*:10000};
1404 start=$(expr $base + %1);
1405 end=$(expr $base + %{?2}%{!?2:%{1}});
1406 echo ": patchset_patch %1%{?2: to %2}";
1407 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1408) \
1409%{nil}
1410
1411# browser plugins v2
1412# Author: Elan Ruusamäe <glen@pld-linux.org>
1413#
1414# Usage:
1415# %browser_plugins_add_browser <name> -p <plugindir>
1416#
1417# <name> (required) -- name of the browser. usually %{name}.
1418# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1419# -b -- default blacklists
1420# -a <arch> override arch
1421#
1422# Example:
1423# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1424
1425%_browserpluginsconfdir /etc/browser-plugins
1426%_browserpluginsdir %{_libdir}/browser-plugins
1427%update_browser_plugins /usr/sbin/update-browser-plugins || :
1428
1429%browser_plugins_add_browser(p:b:a:) \
1430 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1431 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1432 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1433 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1434 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1435 %{-b:cat >> $blacklist_file %{-b*}} \
1436%{nil}
1437
1438# Helper for LUA.
1439# split string separated by space into quoted list
1440#
1441# Author: Elan Ruusamäe <glen@pld-linux.org>
1442#
1443# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1444%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1445
1446# adjust /etc/shells by adding and removing shells from there
1447# Author: Elan Ruusamäe <glen@pld-linux.org>
1448#
1449# Usage:
1450# %post -p <lua>
1451# %lua_add_etc_shells /bin/sh /bin/pdksh
1452#
1453# %preun -p <lua>
1454# if arg[2] == 0 then
1455# %lua_remove_etc_shells /bin/bash /bin/rbash
1456# end
1457#
1458# Requirements:
1459# BuildRequires: rpmbuild(macros) >= 1.462
1460#
1461
1462%lua_add_etc_shells() \
1463t = {}\
1464f = io.open("/etc/shells", "r")\
1465if f then\
1466 for l in f:lines() do t[l]=l; end\
1467 f:close()\
1468end\
1469for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1470 if not t[s] then\
1471 print("Adding "..s.." to /etc/shells")\
1472 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1473 end\
1474end\
1475%{nil}
1476
1477%lua_remove_etc_shells() \
1478t = {}\
1479f = io.open("/etc/shells", "r")\
1480if f then\
1481 for l in f:lines() do t[l]=l; end\
1482 f:close()\
1483end\
1484for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1485 print("Removing "..l.." from /etc/shells")\
1486 t[l] = nil\
1487end\
1488s=""\
1489for _, l in pairs(t) do\
1490 s=s..l.."\\n"\
1491end\
1492io.open("/etc/shells", "w"):write(s)\
1493%{nil}
1494
1495# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1496#
1497# Author: Elan Ruusamäe <glen@pld-linux.org>
1498#
1499# Usage:
1500# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1501# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1502#
1503# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1504#
1505# Requirements:
1506# BuildRequires: rpmbuild(macros) >= 1.429
1507#
1508%add_etc_shells(p) %{-p:<lua>}\
1509%{expand:%%lua_add_etc_shells %*}\
1510%{nil}
1511
1512%remove_etc_shells(p) %{-p:<lua>}\
1513%{-p:if arg[2] == 0 then}\
1514%{expand:%%lua_remove_etc_shells %*}\
1515%{-p:end} \
1516%{nil}
1517
1518# vim:ts=4 sw=4 noet syn=spec
This page took 0.512463 seconds and 4 git commands to generate.